require 'net/http/post/multipart'
require 'JSON'
filename = 'Example.docx'

# Post login request
response = Net::HTTP.post_form(URI.parse('https://api.docconverter.pro/Token'), {grant_type: 'password', username: 'your@email.com', password: 'your_password'})

    
if response.code.to_i == 200
  # Extract token
  token = JSON.parse(response.body)['access_token']

  File.open(filename) do |my_file|
    # Create URI and data params
    uri = URI.parse('https://api.docconverter.pro/api/converter/convertdoc')
    data = {file_name: UploadIO.new(my_file, "application/vnd.openxmlformats-officedocument.wordprocessingml.document", filename), template: 'Convert to HTML5', returnHtml: false, returnData: true}
    
    # Create MULTIPART request
    req = Net::HTTP::Post::Multipart.new uri.path, data

    # Add auth token to request
    req.add_field "Authorization", "Bearer #{token}" 

    http = Net::HTTP.new(uri.host, uri.port)
    http.use_ssl = (uri.scheme == "https")
    
    # Perform request
    res = http.start do |http|
      http.request(req)
    end

    # Write HTML response to file
    open("Example.zip", "wb") do |file|
      file.write(res.body)
	  puts "Document converted, please see Example.zip file content"
    end
  end
else
  puts "Invalid Doc Converter Pro login email or passoword"
end